#ifndef _DATAPORT_h
#define _DATAPORT_h

#include "Arduino.h"
#include "ESP8266WiFi.h"
#include "TypedQueue.h"

typedef String CommandCallbackType(String);


class DataPort {
 private:
   WiFiServer m_server;
   unsigned long m_lastMillis = 0;
   WiFiClient m_client;
   bool m_initialized = false;
   TypedQueue<String> m_queue;
   bool m_debug;
   bool m_enabled;
   
 public:
   DataPort();
   void Begin(uint port);
   void Send(String data);
   bool Handle(CommandCallbackType* callback);
   void AddPayload(String payload);
   void SetDebugMode(boolean mode);
  
   
};

#endif

